searchNodes=[{"doc":"","ref":"Dispatch.html","title":"Dispatch","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Dispatch.html#start/2","title":"Dispatch.start/2","type":"function"},{"doc":"Provides a distributes registry for services. This module implements the Phoenix.Tracker behaviour to provide a distributed registry of services. Services can be added and removed to and from the registry. Services are identified by their type. The type must be a binary. When a node goes down, all associated services will be removed from the registry when the CRDT syncs. A hash ring is used to determine which service to use for a particular term. The term is arbitrary, however the same node and service pid will always be returned for a term unless the number of services for the type changes. Optional :test - If set to true then a registry and hashring will not be started when the application starts. They should be started manually with Dispatch.Registry.start_link/1 and Dispatch.Supervisor.start_hash_ring/2. Defaults to false","ref":"Dispatch.Registry.html","title":"Dispatch.Registry","type":"module"},{"doc":"Add a service to the registry. The service is set as online. type - The type of the service. Must be a binary. pid - The pid that provides the service Examples iex&gt; Dispatch.Registry.add_service(&quot;downloader&quot;, self()) {:ok, &quot;g20AAAAIlB7XfDdRhmk=&quot;}","ref":"Dispatch.Registry.html#add_service/2","title":"Dispatch.Registry.add_service/2","type":"function"},{"doc":"Set a service as offline. When a service is offline it can&#39;t be used. type - The type of the service. Must be a binary. pid - The pid that provides the service Examples iex&gt; Dispatch.Registry.disable_service(&quot;downloader&quot;, self()) {:ok, &quot;g20AAAAI4oU3ICYcsoQ=&quot;}","ref":"Dispatch.Registry.html#disable_service/2","title":"Dispatch.Registry.disable_service/2","type":"function"},{"doc":"Set a service as online. When a service is online it can be used. type - The type of the service. Must be a binary. pid - The pid that provides the service Examples iex&gt; Dispatch.Registry.enable_service(&quot;downloader&quot;, self()) {:ok, &quot;g20AAAAI9+IQ28ngDfM=&quot;}","ref":"Dispatch.Registry.html#enable_service/2","title":"Dispatch.Registry.enable_service/2","type":"function"},{"doc":"Find a list of count service instances to use for a particular key count - The number of service instances to retrieve type - The type of services to retrieve key - The key to lookup the service. Can be any elixir term Examples iex&gt; Dispatch.Registry.find_multi_service(2, :uploader, &quot;file.png&quot;) [{:ok, :&quot;slave1@127.0.0.1&quot;, #PID&lt;0.153.0&gt;}, {:ok, :&quot;slave2@127.0.0.1&quot;, #PID&lt;0.145.0&gt;}]","ref":"Dispatch.Registry.html#find_multi_service/3","title":"Dispatch.Registry.find_multi_service/3","type":"function"},{"doc":"Find a service to use for a particular key type - The type of the service. Must be a binary. key - The key to lookup the service. Can be any elixir term Examples iex&gt; Dispatch.Registry.find_service(:uploader, &quot;file.png&quot;) {:ok, :&quot;slave1@127.0.0.1&quot;, #PID&lt;0.153.0&gt;}","ref":"Dispatch.Registry.html#find_service/2","title":"Dispatch.Registry.find_service/2","type":"function"},{"doc":"List all of the services that are online for a particular type. type - The type of the service. Must be a binary. Examples iex&gt; Dispatch.Registry.get_online_services(&quot;downloader&quot;) [{#PID&lt;0.166.0&gt;, %{node: :&quot;slave2@127.0.0.1&quot;, phx_ref: &quot;g20AAAAIHAHuxydO084=&quot;, phx_ref_prev: &quot;g20AAAAI4oU3ICYcsoQ=&quot;, state: :online}}]","ref":"Dispatch.Registry.html#get_online_services/1","title":"Dispatch.Registry.get_online_services/1","type":"function"},{"doc":"List all of the services for a particular type. type - The type of the service. Must be a binary. Examples iex&gt; Dispatch.Registry.get_services(&quot;downloader&quot;) [{#PID&lt;0.166.0&gt;, %{node: :&quot;slave2@127.0.0.1&quot;, phx_ref: &quot;g20AAAAIHAHuxydO084=&quot;, phx_ref_prev: &quot;g20AAAAI4oU3ICYcsoQ=&quot;, state: :online}}]","ref":"Dispatch.Registry.html#get_services/1","title":"Dispatch.Registry.get_services/1","type":"function"},{"doc":"Remove a service from the registry. type - The type of the service. Must be a binary. pid - The pid that provides the service Examples iex&gt; Dispatch.Registry.remove_service(&quot;downloader&quot;, self()) {:ok, &quot;g20AAAAI4oU3ICYcsoQ=&quot;}","ref":"Dispatch.Registry.html#remove_service/2","title":"Dispatch.Registry.remove_service/2","type":"function"},{"doc":"Start a new registry. The pubsub config value from Dispatch will be used. Examples iex&gt; Dispatch.Registry.start_link() {:ok, #PID&lt;0.168.0&gt;}","ref":"Dispatch.Registry.html#start_link/1","title":"Dispatch.Registry.start_link/1","type":"function"},{"doc":"","ref":"Dispatch.Service.html","title":"Dispatch.Service","type":"module"},{"doc":"","ref":"Dispatch.Service.html#call/4","title":"Dispatch.Service.call/4","type":"function"},{"doc":"","ref":"Dispatch.Service.html#cast/3","title":"Dispatch.Service.cast/3","type":"function"},{"doc":"","ref":"Dispatch.Service.html#init/1","title":"Dispatch.Service.init/1","type":"function"},{"doc":"","ref":"Dispatch.Service.html#multi_call/5","title":"Dispatch.Service.multi_call/5","type":"function"},{"doc":"","ref":"Dispatch.Service.html#multi_cast/4","title":"Dispatch.Service.multi_cast/4","type":"function"},{"doc":"","ref":"Dispatch.Supervisor.html","title":"Dispatch.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Dispatch.Supervisor.html#child_spec/1","title":"Dispatch.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Dispatch.Supervisor.html#init/1","title":"Dispatch.Supervisor.init/1","type":"function"},{"doc":"","ref":"Dispatch.Supervisor.html#start_link/1","title":"Dispatch.Supervisor.start_link/1","type":"function"},{"doc":"Dispatch A distributed service registry built on top of phoenix_pubsub. Requests are dispatched to one or more services based on hashed keys.","ref":"readme.html","title":"Dispatch","type":"extras"},{"doc":"Add dispatch to your list of dependencies in mix.exs: def deps do [ {:dispatch, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"Dispatch - Installation","type":"extras"},{"doc":"Configuration Configure the registry: config :dispatch, pubsub: [name: Dispatch.PubSub, adapter: Phoenix.PubSub.PG2, opts: [pool_size: 1]], registry: [log_level: :debug, broadcast_period: 25, max_silent_periods: 3] When the application is started, a supervisor with be started supervising a pubsub adapter with the name and options specified. One can also customize the tracker options for the registry. Register a service iex&gt; {:ok, service_pid} = Agent.start_link(fn -&gt; 1 end) # Use your real service here iex&gt; Dispatch.Registry.add_service(:uploader, service_pid) {:ok, &quot;g20AAAAI9+IQ28ngDfM=&quot;} In this example, :uploader is the type of the service. Retrieve all services for a service type iex&gt; Dispatch.Registry.get_services(:uploader) [{#PID&lt;0.166.0&gt;, %{node: :&quot;slave2@127.0.0.1&quot;, phx_ref: &quot;g20AAAAIHAHuxydO084=&quot;, phx_ref_prev: &quot;g20AAAAI4oU3ICYcsoQ=&quot;, state: :online}}] This retrieves all of the services info. Finding a service for a key iex&gt; Dispatch.Registry.find_service(:uploader, &quot;file.png&quot;) {:ok, :&quot;slave1@127.0.0.1&quot;, #PID&lt;0.153.0&gt;} Using find_service/2 returns a tuple in the form {:ok, node, pid} where node is the node that owns the service pid. If no service can be found then {:error, reason} is returned. Finding a list of count service instances for a particular key iex&gt; Dispatch.Registry.find_multi_service(2, :uploader, &quot;file.png&quot;) [{:ok, :&quot;slave1@127.0.0.1&quot;, #PID&lt;0.153.0&gt;}, {:ok, :&quot;slave2@127.0.0.1&quot;, #PID&lt;0.145.0&gt;}]","ref":"readme.html#usage","title":"Dispatch - Usage","type":"extras"},{"doc":"The Service module can be used to automatically handle registration of a service based on a GenServer. Call Service.init within your GenServer&#39;s init function. def init(_) do :ok = Dispatch.Service.init(type: :uploader) {:ok, %{}} end This will use the type provided to attach a service to the configured registry pid. Use Dispatch.Service.cast and Dispatch.Service.call to route the GenServer cast or call to the appropriate service based on the key provided. Use Dispatch.Service.multi_cast to send cast messages to several service instances at once. Dispatch.Service.multi_call calls several service instances and waits for all the responses before returning. # File is a map with the format %{name: &quot;file.png&quot;, contents: &quot;test file&quot;} def upload(file) Dispatch.Service.cast(:uploader, file.name, {:upload, file}) end def download(file) Dispatch.Service.call(:uploader, file.name, {:download, file}) end def handle_cast({:upload, file}, state) do Logger.info(&quot;Uploading \#{file.name}&quot;) {:noreply, Map.put(state, file.name, file.contents)} end def handle_call({:download, %{name: name}}, from, state) do Logger.info(&quot;Downloading \#{name}&quot;) {:reply, {:ok, Map.get(state, name}}, state} end","ref":"readme.html#convenience-api","title":"Dispatch - Convenience API","type":"extras"}]